module.exports = function createMenu(navigationData) {
    let rootapp = document.createElement("div");
    let styles = [];
    async function crNodeElApp(type, children) {
        let temp = await document.createElement("div");
        if (DecodedJson.components[type]) {
            for (var prName in DecodedJson.components[type]) {
                temp.setAttribute(prName, DecodedJson.components[type][prName]);
            }
        }
        await children.map(async (el) => {
            if (!el.type) temp.innerHTML += el
            else if (el.type == "node") {
                let temp2 = await crNodeElApp(el.type, el.children);
                await temp.append(temp2)
            }
            else {
                let temp2 = await crElApp(el.type, el.props);
                await temp.append(temp2)
            }
        })

        return temp;
    }
    async function crElApp(type, props) {
        let temp = await document.createElement(type == "link" ? "a" : "button");
        for (var propName in props) {
            if (propName != "children")
                temp.setAttribute(propName, props[propName]);
            else
                props[propName].map(async (el) => {
                    if (!el.type) temp.innerHTML += el
                    else if (el.type == "node") {
                        let temp2 = await crNodeElApp(el.type, el.children);
                        await temp.append(temp2)
                    }
                    else {
                        let temp2 = await crElApp(el.type, el.props);
                        await temp.append(temp2)
                    }
                })
        }
        if (DecodedJson.components[type]) {
            for (var prName in DecodedJson.components[type]) {
                if (!temp.getAttribute(prName))
                temp.setAttribute(prName, DecodedJson.components[type][prName]);
            }
        }
        return temp;
    }
    let DecodedJson = JSON.parse(navigationData)

    DecodedJson.structure.map(async (el) => {
        if (el.type == "node") {
            let temp = await crNodeElApp(el.type, el.children);

            await rootapp.append(temp);
        }
        else {
            let temp = await crElApp(el.type, el.props);

            await rootapp.append(temp);
        }
    })
    return rootapp;
}